#! /usr/bin/python
# -*- coding: iso-8859-1 -*-

# -----------------------------------------------------------------------------

# Convert RSS feed to an HTML page
#
# Copyright (C) 2008 by Ivo van Poorten
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of version 2 of the GNU General Public License as
# published by the Free Software Foundation.

# -----------------------------------------------------------------------------

import feedparser, optparse, sys

# -----------------------------------------------------------------------------

HEADER = """\
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=%s">
        <link rel="stylesheet" type="text/css" href="default.css">
        <title>
            %s
        </title>
    </head>

<body>
"""

TRAILER = """\
</body>
</html>
"""

BODYSTART = """\
<table>
"""

TOPSTART = """\
    <tr>
"""

TOPLEFT = """\
        <td class="topleft">
            generated by <a href="http://repo.or.cz/w/rss2html.py.git">rss2html.py</a> &copy;2008
        </td>
"""

TOPRIGHT1 = """\
        <td class="rightside">
            <a name="top"></a>
            <div class="heading">
                <table>
                    <tr>
                        <td class="left">
                            <b>title:</b>
                        </td>
                        <td class="right">
                            %s
                        </td>
                    </tr>
                    <tr>
                        <td class="left">
                            <b>description:</b>
                        </td>
                        <td class="right">
                            %s
                        </td>
                    </tr>
                        <tr>
                            <td class="left">
                                <b>link:</b>
                            </td>
                        <td class="right">
                            %s
                        </td>
                    </tr>
"""

TOPRIGHT2 = """\
                    <tr>
                        <td class="left">
                            <b>publication date:</b>
                        </td>
                        <td class="right">
                            %s
                        </td>
                    </tr>
                    <tr>
                        <td class="left">
                            <b>generator:</b>
                        </td>
                        <td class="right">
                            %s
                        </td>
                    </tr>
                    <tr>
                        <td class="left">
                            <b>language:</b>
                        </td>
                        <td class="right">
                            %s
                        </td>
                    </tr>
"""

TOPRIGHT3 = """\
                </table>
            </div>
        </td>
"""

TOPEND = """\
    </tr>
"""

BOTTOMSTART = """\
    <tr>
"""

BOTTOMLEFT1 = """\
        <td class="leftside">
            <div class="toc">
                <b> Table of contents </b>
                <p>
                <ul>
"""

BOTTOMLEFT2 = """\
                    <li> <a href="#%s"> %s </a> <br>
"""

BOTTOMLEFT3 = """\
                </ul>
            </div>
            <div class="rssfeed">
                <a href="%s">
                    RSS Feed&nbsp;<img src="feed.png" alt="feed">
                </a>
            </div>
        </td>
"""

BOTTOMRIGHT1 = """\
        <td class="rightside">
"""

BOTTOMRIGHT2 = """\
            <div class="item">
                <a name="%s"></a>
                <table>
                    <tr>
                        <td class="left">
                            <b>title:</b>
                        </td>
                        <td class="right">
                            %s
                        </td>
                    </tr>
                    <tr>
                        <td class="left">
                            <b>publication date:</b>
                        </td>
                        <td class="right">
                            %s
                        </td>
                    </tr>
                    <tr>
                        <td class="left">
                            <b>author:</b>
                        </td>
                        <td class="right">
                            %s
                        </td>
                    </tr>
                    <tr>
                        <td class="left">
                            <b>description:</b>
                        </td>
                        <td class="right">
                            %s
                        </td>
                    </tr>
                    <tr>
                        <td class="left">
                            <b> </b>
                        </td>
                        <td class="right">
                            <a href="#top">top</a> %s %s
                        </td>
                    </tr>
                </table>
            </div>
"""

BOTTOMRIGHT3 = """\
        </td>
"""

BOTTOMEND = """\
    </tr>
"""

BODYEND = """\
</table>
"""

# -----------------------------------------------------------------------------

class html_page:
    def __init__(self, d, outfile, options):
        self.d = d
        self.encoding = 'utf-8'
        self.title    = self.__field(d['feed'], 'title')
        self.outfile  = outfile
        self.options  = options

    def __field(self, src, field, fallback=""):
        if field in src:
            return src[field].encode(self.encoding)
        else:
            if fallback == "":
                return ''.encode(self.encoding)
            else:
                return fallback.encode(self.encoding)

    def __header(self):
        self.output.write(HEADER % (self.encoding, self.title) )

    def __trailer(self):
        self.output.write(TRAILER)

    def __url(self, url):
        x = '<a href="%s">%s</a>' % (url, url)
        return x.encode(self.encoding)

    def __url2(self, url, text):
        x = '<a href="%s">%s</a>' % (url, text)
        return x.encode(self.encoding)

    def __body(self):
        field = self.__field
        feed  = self.d['feed']

        self.output.write(BODYSTART)
        self.output.write(TOPSTART)
        self.output.write(TOPLEFT)

        self.output.write(TOPRIGHT1.encode(self.encoding) % (self.title, field(feed, 'description'), self.__url(field(feed, 'link')) ))

        if self.options.long == True:
            self.output.write(TOPRIGHT2.encode(self.encoding) % (field(feed, 'updated'), self.__url(field(feed, 'generator')), field(feed, 'language') ) )

        self.output.write(TOPRIGHT3)
        self.output.write(TOPEND)
        self.output.write(BOTTOMSTART)
        self.output.write(BOTTOMLEFT1)

        j = 1;
        for i in self.d.entries:
            self.output.write(BOTTOMLEFT2.encode(self.encoding) %
                (str(j),
                 field(i, 'title')) )
            j += 1

        self.output.write(BOTTOMLEFT3 % self.options.rssfeed)
        self.output.write(BOTTOMRIGHT1)

        j = 1;
        for i in self.d.entries:
            if self.options.fullstory == True:
                fullstory = '| ' + self.__url2(field(i, 'link'), 'full story')
            else:
                fullstory = ''
            if self.options.comments == True:
                comments = '| ' + self.__url2(field(i, 'comments'), 'comments')
            else:
                comments = ''
            content = field(i, 'description')
            try:
                content = i.content[0]['value']
            except:
                pass
            self.output.write(BOTTOMRIGHT2.encode(self.encoding) % 
                (str(j),
                 field(i, 'title'),
                 field(i, 'updated'),
                 field(i, 'author'),
                 content,
                 fullstory,
                 comments) )
            j += 1

        self.output.write(BOTTOMRIGHT3)
        self.output.write(BOTTOMEND)
        self.output.write(BODYEND)

    def page(self):
        if self.outfile == '-':
            self.output = sys.stdout
        else:
            self.output = open(self.outfile, "wb")
        self.__header()
        self.__body()
        self.__trailer()
        if self.output != sys.stdout:
            self.output.close()

# -----------------------------------------------------------------------------

def main():
    p = optparse.OptionParser("usage: %prog infile [outfile]",
                              version="%prog 0.9")

    p.add_option("-l", "--long-heading", dest="long", action="store_true", default="False", help="display long heading")
    p.add_option("-f", "--full-story", dest="fullstory", action="store_true", default="False", help="display full story link")
    p.add_option("-c", "--comments", dest="comments", action="store_true", default="False", help="display comments link")
    p.add_option("-r", "--rss-feed", dest="rssfeed", help="force RSS Feed to specific address")

    (options, args) = p.parse_args()

    if len(args) == 1:
        outfile = '-'
    elif len(args) == 2:
        outfile = args[1]
    else:
        p.parse_args(['-h'])

    if options.rssfeed == None:
        options.rssfeed = args[0]

    html_page(feedparser.parse(args[0]), outfile, options).page()

if __name__ == "__main__":
    main()

# -----------------------------------------------------------------------------
